// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _CLUTTERMM_ALPHA_H
#define _CLUTTERMM_ALPHA_H


#include <glibmm.h>

/* Copyright (C) 2007 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <cluttermm/timeline.h>
#include <clutter/clutter-alpha.h>
 

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterAlpha ClutterAlpha;
typedef struct _ClutterAlphaClass ClutterAlphaClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Alpha_Class; } // namespace Clutter
namespace Clutter
{


class Alpha : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Alpha CppObjectType;
  typedef Alpha_Class CppClassType;
  typedef ClutterAlpha BaseObjectType;
  typedef ClutterAlphaClass BaseClassType;

private:  friend class Alpha_Class;
  static CppClassType alpha_class_;

private:
  // noncopyable
  Alpha(const Alpha&);
  Alpha& operator=(const Alpha&);

protected:
  explicit Alpha(const Glib::ConstructParams& construct_params);
  explicit Alpha(ClutterAlpha* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Alpha();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterAlpha*       gobj()       { return reinterpret_cast<ClutterAlpha*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterAlpha* gobj() const { return reinterpret_cast<ClutterAlpha*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterAlpha* gobj_copy();

private:

  
protected:
  Alpha();

public:

  /** For instance,
   * guint32 on_alpha(const Glib::RefPtr<Alpha>& alpha);
   */
  typedef sigc::slot<guint32, const Glib::RefPtr<Alpha>& > SlotAlphaFunc;

protected:
  /** Creates a new Alpha instance and sets the timeline and the alpha function.
   * @param timeline Timeline.
   * @param slot Alpha function.
   */
  Alpha(const Glib::RefPtr<Timeline>& timeline, const SlotAlphaFunc& slot);

  /** Creates a new Alpha instance and sets the timeline and the alpha function.
   * @param timeline Timeline.
   * @param slot Alpha function.
   */
  Alpha(const Glib::RefPtr<Timeline>& timeline, ClutterAlphaFunc callback);

public:
  
  static Glib::RefPtr<Alpha> create();

  
  static Glib::RefPtr<Alpha> create(const Glib::RefPtr<Timeline>& timeline, const SlotAlphaFunc& slot);

  
  static Glib::RefPtr<Alpha> create(const Glib::RefPtr<Timeline>& timeline, ClutterAlphaFunc callback);


  /** Binds @a alpha to @a timeline.
   * 
   * Since: 0.2
   * @param timeline A Clutter::Timeline.
   */
  void set_timeline(const Glib::RefPtr<Timeline>& timeline);
  
  /** Gets the Clutter::Timeline bound to @a alpha.
   * @return A Clutter::Timeline instance
   * 
   * Since: 0.2.
   */
  Glib::RefPtr<Timeline> get_timeline() const;
  
  /** Query the current alpha value.
   * @return The current alpha value for the alpha
   * 
   * Since: 0.2.
   */
  guint32 get_alpha() const;

  void set_func(const SlotAlphaFunc& slot);
  

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Alpha value.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<guint> property_alpha() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Timeline.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<Timeline> > property_timeline() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Timeline.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Timeline> > property_timeline() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  // We don't need the GClosure stuff in C++:
  

public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

/// @name Pre-defined Alpha functions
/// @related Alpha
/// @{
extern Alpha::SlotAlphaFunc ALPHA_RAMP_INC;
extern Alpha::SlotAlphaFunc ALPHA_RAMP_DEC;
extern Alpha::SlotAlphaFunc ALPHA_RAMP;
extern Alpha::SlotAlphaFunc ALPHA_SINE;
extern Alpha::SlotAlphaFunc ALPHA_SINE_INC;
extern Alpha::SlotAlphaFunc ALPHA_SINE_DEC;
extern Alpha::SlotAlphaFunc ALPHA_SINE_HALF;
extern Alpha::SlotAlphaFunc ALPHA_SQUARE;
extern Alpha::SlotAlphaFunc ALPHA_SMOOTHSTEP_INC;
extern Alpha::SlotAlphaFunc ALPHA_SMOOTHSTEP_DEC;
extern Alpha::SlotAlphaFunc ALPHA_EXP_INC;
extern Alpha::SlotAlphaFunc ALPHA_EXP_DEC;
/// @}

} // namespace Clutter
// vim:ts=2,sw=2


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Alpha
   */
  Glib::RefPtr<Clutter::Alpha> wrap(ClutterAlpha* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_ALPHA_H */

