// Generated by gtkmmproc -- DO NOT MODIFY!


#include <cluttermm/behaviour-bspline.h>
#include <cluttermm/private/behaviour-bspline_p.h>

/* Copyright (C) 2007 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <clutter/clutter-behaviour-bspline.h>

namespace Clutter
{

BehaviourBspline::BehaviourBspline(const Glib::RefPtr<Alpha>& alpha, const Glib::ArrayHandle<Knot>& knots)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Behaviour(Glib::ConstructParams(behaviourbspline_class_.init(), "alpha",Glib::unwrap(alpha), static_cast<char*>(0)))
{
  for(Glib::ArrayHandle<Knot>::const_iterator iter = knots.begin(); iter != knots.end(); ++ iter)
  {
    append_knot(*iter);
  }
}

Knot BehaviourBspline::get_origin() const
{
  Knot knot;
  clutter_behaviour_bspline_get_origin(const_cast<ClutterBehaviourBspline*>(gobj()), knot.gobj());
  return knot;
}

} //namespace Clutter


namespace
{


static void BehaviourBspline_signal_knot_reached_callback(ClutterBehaviourBspline* self, const ClutterKnot* p0,void* data)
{
  using namespace Clutter;
  typedef sigc::slot< void,const Knot& > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Knot(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo BehaviourBspline_signal_knot_reached_info =
{
  "knot_reached",
  (GCallback) &BehaviourBspline_signal_knot_reached_callback,
  (GCallback) &BehaviourBspline_signal_knot_reached_callback
};


} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Clutter::BehaviourBspline> wrap(ClutterBehaviourBspline* object, bool take_copy)
{
  return Glib::RefPtr<Clutter::BehaviourBspline>( dynamic_cast<Clutter::BehaviourBspline*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Clutter
{


/* The *_Class implementation: */

const Glib::Class& BehaviourBspline_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &BehaviourBspline_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(clutter_behaviour_bspline_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:
  Scriptable::add_interface(get_type());

  }

  return *this;
}

void BehaviourBspline_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  klass->knot_reached = &knot_reached_callback;
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
void BehaviourBspline_Class::knot_reached_callback(ClutterBehaviourBspline* self, const ClutterKnot* p0)
{
  Glib::ObjectBase *const obj_base = static_cast<Glib::ObjectBase*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj_base && obj_base->is_derived_())
  {
    CppObjectType *const obj = dynamic_cast<CppObjectType* const>(obj_base);
    if(obj) // This can be NULL during destruction.
    {
      #ifdef GLIBMM_EXCEPTIONS_ENABLED
      try // Trap C++ exceptions which would normally be lost because this is a C callback.
      {
      #endif //GLIBMM_EXCEPTIONS_ENABLED
        // Call the virtual member method, which derived classes might override.
        obj->on_knot_reached(Knot(p0)
);
        return;
      #ifdef GLIBMM_EXCEPTIONS_ENABLED
      }
      catch(...)
      {
        Glib::exception_handlers_invoke();
      }
      #endif //GLIBMM_EXCEPTIONS_ENABLED
    }
  }
  
  BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

  // Call the original underlying C function:
  if(base && base->knot_reached)
    (*base->knot_reached)(self, p0);
}
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* BehaviourBspline_Class::wrap_new(GObject* object)
{
  return new BehaviourBspline((ClutterBehaviourBspline*)object);
}


/* The implementation: */

ClutterBehaviourBspline* BehaviourBspline::gobj_copy()
{
  reference();
  return gobj();
}

BehaviourBspline::BehaviourBspline(const Glib::ConstructParams& construct_params)
:
  Behaviour(construct_params)
{

}

BehaviourBspline::BehaviourBspline(ClutterBehaviourBspline* castitem)
:
  Behaviour((ClutterBehaviour*)(castitem))
{}

BehaviourBspline::~BehaviourBspline()
{}


BehaviourBspline::CppClassType BehaviourBspline::behaviourbspline_class_; // initialize static member

GType BehaviourBspline::get_type()
{
  return behaviourbspline_class_.init().get_type();
}

GType BehaviourBspline::get_base_type()
{
  return clutter_behaviour_bspline_get_type();
}


Glib::RefPtr<BehaviourBspline> BehaviourBspline::create(const Glib::RefPtr<Alpha>& alpha, const Glib::ArrayHandle<Knot>& knots)
{
  return Glib::RefPtr<BehaviourBspline>( new BehaviourBspline(alpha, knots) );
}
void BehaviourBspline::append_knot(const Knot& knot)
{
clutter_behaviour_bspline_append_knot(gobj(), (knot).gobj()); 
}

void BehaviourBspline::truncate(guint offset)
{
clutter_behaviour_bspline_truncate(gobj(), offset); 
}

void BehaviourBspline::join(const Glib::RefPtr<const BehaviourBspline>& bs2)
{
clutter_behaviour_bspline_join(gobj(), const_cast<ClutterBehaviourBspline*>(Glib::unwrap(bs2))); 
}

Glib::RefPtr<BehaviourBspline> BehaviourBspline::split(guint offset)
{
  return Glib::wrap(reinterpret_cast<ClutterBehaviourBspline*>(clutter_behaviour_bspline_split(gobj(), offset)), true);
}

void BehaviourBspline::clear()
{
clutter_behaviour_bspline_clear(gobj()); 
}

void BehaviourBspline::adjust(guint offset, Knot& knot)
{
clutter_behaviour_bspline_adjust(gobj(), offset, (knot).gobj()); 
}

void BehaviourBspline::set_origin(Knot& knot)
{
clutter_behaviour_bspline_set_origin(gobj(), (knot).gobj()); 
}


Glib::SignalProxy1< void,const Knot& > BehaviourBspline::signal_knot_reached()
{
  return Glib::SignalProxy1< void,const Knot& >(this, &BehaviourBspline_signal_knot_reached_info);
}


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
void Clutter::BehaviourBspline::on_knot_reached(const Knot& knot)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->knot_reached)
    (*base->knot_reached)(gobj(),(knot).gobj());
}
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Clutter


